/* Copyright 1999-2007 The Apache Software Foundation or its licensors, as
 * applicable.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

/*
 * Original Copyright (c) Netmask.IT! 2006-2007
 *
 * DNS Protocol module for Apache 2.x
 */

#include "../rr.h"

static DNS_RDATA_UNSERIALIZE(a) {
    dns_rdata_t *rrdata;
    
    dns_rdata_a_t *addr = apr_pcalloc(pool, sizeof(*addr));
    *rdata = rrdata = apr_pcalloc(pool, sizeof(*rrdata));
    dns_init_rdata_const(a, rrdata);
    rrdata->rdata = addr;

    memcpy(&(addr->address), data, sizeof(apr_uint32_t));
    addr->address = ntohl(addr->address);  

    return APR_SUCCESS;
}

static DNS_RDATA_SERIALIZE(a) {
    dns_rdata_a_t *addr;
    *dlen = sizeof(apr_uint32_t);
    if (data == NULL)
        return APR_SUCCESS;
    addr = (dns_rdata_a_t *)rdata;
    addr->address = htonl(addr->address);
    memcpy(data, (const void *)&(addr->address), *dlen);
    return APR_SUCCESS;
}

static DNS_RDATA_PSERIALIZE(a)

DNS_RDATA_IMPLEMENT(a);

